/***************************************************************************
                          extractdlg.h  -  description
                             -------------------
    begin                : Sun Apr 8 2001
    copyright            : (C) 2001 by Javier Campos Morales
    email                : javi_cms@terra.es
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef EXTRACTDLG_H
#define EXTRACTDLG_H

#include <qwidget.h>
#include <kdialogbase.h>
#include <kurl.h>
#include <kurlrequester.h>
#include <kprocess.h>

#include <qlabel.h>
#include <qmultilineedit.h>
#include <qradiobutton.h>

/**Extract options
  *@author Javier Campos Morales
  */

class ExtractDlg : public KDialogBase  {
   Q_OBJECT
public: 
	ExtractDlg( QWidget *parent=0, const char *name=0 );
	~ExtractDlg();
  /** Set name of the file */
  void setFile(const KURL &url);
  /** Set name of the file */
  KURL getFile();
  /** Extract in personal directory */
  QString extractDir();
  /** Extract in current dir */
  bool isCurrentDir();
private: // Private methods
  /** Execute a command */
  void execute(const char *file);
  /** Init graphical interface */
  void initGUI();
protected slots: // Protected slots
  /** No descriptions */
  void slotOk();
private: // Private attributes
	/** Shell process configure --help */
	KShellProcess q;
  QLabel *FileName_label;
  QLabel *DirName_label;
	QRadioButton *extractCurrent_radio;
	QRadioButton *extractDir_radio;
	KURLRequester *kurlrequest;
  QString streamLine;
	QMultiLineEdit *view_extractfiles;
private slots: // Private slots
  /** Check radio compress */
  void slotExtractCheck();
  /** No descriptions */
  void slotOutputMessages(KProcess*,char *buffer,int buflen);
  /** No descriptions */
  void slotFinishAction();
};

#endif
