	/***************************************************************************
                          kconfigure.h  -  description
                             -------------------
    begin                : sb abr 28 16:26:37 CEST 2001
    copyright            : (C) 2001 by Javier Campos
    email                : javi_cms@terra.es
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KCONFIGURE_H
#define KCONFIGURE_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "pageview.h"
#include "pageconfigure.h"
#include "pagemake.h"
#include "pagerun.h"

#include <kapp.h>
#include <kwizard.h>
#include <klocale.h>

/** Kconfigure is the base class of the porject */
class Kconfigure : public KWizard
{
  Q_OBJECT 
  public:
	/** construtor */
	Kconfigure(QWidget *parent = 0, const char *name = 0, bool modal = false, WFlags f = 0);
	/** destructor */
	~Kconfigure();
  /** Show page operations */
  void showPage( QWidget *);
  /** Open url */
  bool openURL( const KURL &url);
  /** Open new Documents */
  bool openNew();
private: // Private methods
  /** Make options page */
  void setPageMake();
  /** View files page */
  void setPageView();
  /** Configure options page */
  void setPageConfigure();
  /** No descriptions */
  void setPageRun();
  /** Open an extract file */
  bool openExtractURL( const KURL &url);
  /** Config read */
  void configRead();
private: // Private attributes
  /** main file url */
  KURL urlProyect;
  /** Page view files */
  PageView *page_view;
  /** Page configure */
  PageConfigure *page_conf;
  /** Page make */
  PageMake *page_make;
  /** Page run */
  PageRun *page_run;
  /** Is configure in path? */
  bool isConfigure;
};

#endif
