/***************************************************************************
                          makecvs.h  -  description
                             -------------------
    begin                : Thu Aug 30 2001
    copyright            : (C) 2001 by Javier Campos
    email                : javi_cms@terra.es
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MAKECVS_H
#define MAKECVS_H

#include <kdialogbase.h>
#include <kanimwidget.h>
#include <kprocess.h>
#include <kurl.h>

#include <qlabel.h>
#include <qmultilineedit.h>
#include <qpushbutton.h>
#include <qdir.h>

/**Make cvs files
  *@author Javier Campos
  */

class MakeCVS : public KDialogBase  {
   Q_OBJECT
public:
	MakeCVS( QWidget *parent=0, const char *name=0 );
	~MakeCVS();
  /** Set path */
  void setPath( const KURL &);
  /** MakeFile */
  void setMakefile( const QString &file );
private: // Private methods
  /** Init graphical interface */
  void initGUI();
  /** Execute a command */
  void execute( const char *command);
private: // Private attributes
  /** Processes */
  KShellProcess q;
	/** Misc Widgets */
  QLabel *label_info;
	KAnimWidget *pixmap_runstatus;
  /** Status */
  QLabel *label_runstatusinfo;
  /** Output messages */
  QMultiLineEdit *view_status;
  /** Start */
  QPushButton *button_runstart;
  /** Stop */
  QPushButton *button_runstop;
  /** Makefile */
  QString ArgumentsCVS;
  /** qdir path */
  QDir qDir;
  /** Output lines */
  QString streamLine;
private slots: // Private slots
  /** Stop action */
  void slotStop();
  /** Start action */
  void slotStart();
  /** Finish action */
  void slotFinishAction();
  /** Output process */
  void slotOutputMessages(KProcess*,char *buffer,int buflen);
  /** Slot Ok */
  void slotOk();
};

#endif
