/***************************************************************************
                          pagemake.h  -  description
                             -------------------
    begin                : Sat Apr 28 2001
    copyright            : (C) 2001 by Javier Campos
    email                : javi_cms@terra.es
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PAGEMAKE_H
#define PAGEMAKE_H

#include "predefined.h"

#include <knuminput.h>

#include <qwidget.h>
#include <qcombobox.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qcheckbox.h>
#include <qlineedit.h>

/**Makefile options
  *@author Javier Campos
  */

class PageMake : public QWidget  {
   Q_OBJECT
public: 
	PageMake(QWidget *parent=0, const char *name=0);
	~PageMake();
  /** Return make arguments */
  QString getArguments();
  /** Return install arguments */
  QString getArgumentsInstall();
  /** Return install arguments */
  QString getArgumentsInstallMode();
  /** Write config settings */
  void configWrite();
private: // Private methods
  /** Init graphical interface */
  void initGUI();
  /** Fill default arguments */
  void fillDefault();
  /** Fill predefined options */
  void fillPred();
  /** Save predefined options */
  void PredefinedSave( const QString &group);
  /** Read config settings */
  void configRead();
private: // Private attributes
  /** Predefined make options */
  QComboBox *combo_pred_make;
  /** Save predefined make options */
  QPushButton *button_pred_makesave;
  /** Remove predefined make options */
  QPushButton *button_pred_makeremove;
  /** Debug option */
//  QCheckBox *check_makedebug;
  /** Make continue after error */
//  QCheckBox *check_makeerror;
  /** Makefile Jobs */
  KIntSpinBox *spin_makejob;
  /** Make arguments */
  QLineEdit *edit_makeline;
  /** Install as root */
  QRadioButton *radio_installroot;
  /** Install as user */
  QRadioButton *radio_installuser;
  /** Normal Install */
  QRadioButton *radio_installnormal;
  /** Install by checkinstall */
  QRadioButton *radio_installcheck;
  /** Debian Install */
  QRadioButton *radio_installdebian;
  /** Install Arguments */
  QRadioButton *radio_installmanual;
  /** Install Arguments */
  QLineEdit *edit_installmanual;
  /** Predefined options */
  predefined *pred_make;
private slots: // Private slots
  /** No descriptions */
  void slotPredSelect( int );
  /** No descriptions */
  void slotPredRemove();
  /** No descriptions */
  void slotPredSave();
  /** No descriptions */
  void slotRadioInstall();
};

#endif
