/***************************************************************************
                          pagerun.cpp  -  description
                             -------------------
    begin                : Sat Apr 28 2001
    copyright            : (C) 2001 by Javier Campos
    email                : javi_cms@terra.es
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "pagerun.h"
#include "pagerun.moc"

#include <klocale.h>
#include <kstddirs.h>
#include <kmessagebox.h>
#include <knotifyclient.h>

#include <qstring.h>
#include <qframe.h>
#include <qlayout.h>
#include <qgroupbox.h>
#include <qscrollview.h>
#include <qvbox.h>

PageRun::PageRun(QWidget *parent, const char *name ) : QWidget(parent,name)
{
	initGUI();
	QObject::connect
( &q, SIGNAL(receivedStdout(KProcess *, char *, int)),this,SLOT(slotOutputMessages(KProcess *, char *, int)));
	QObject::connect( &q, SIGNAL(receivedStderr(KProcess *, char *, int)),this,SLOT(slotOutputMessages(KProcess *, char *, int)));
	QObject::connect( &q, SIGNAL(processExited(KProcess *)),this, SLOT(slotFinishAction()) );
}

PageRun::~PageRun()
{
}

/** Init Graphical Interface */
void PageRun::initGUI()
{
    QHBoxLayout *pageLayout_4 = new QHBoxLayout( this );
    pageLayout_4->setSpacing( 6 );

    QFrame *Frame14 = new QFrame( this, "Frame14" );
    Frame14->setMinimumSize( QSize( 125, 0 ) );
    Frame14->setMaximumSize( QSize( 125, 32767 ) );
    Frame14->setBackgroundPixmap( QPixmap(locate("appdata","pics/bk_frame.png")) );
    Frame14->setFrameShape( QFrame::Box );
    Frame14->setFrameShadow( QFrame::Plain );

    QVBoxLayout *Frame14Layout = new QVBoxLayout( Frame14 );
    Frame14Layout->setSpacing( 6 );
    Frame14Layout->setMargin( 11 );

    QLabel *pixmap_run = new QLabel( Frame14, "pixmap_run" );
    pixmap_run->setMinimumSize( QSize( 48, 48 ) );
    pixmap_run->setMaximumSize( QSize( 48, 48 ) );
    pixmap_run->setBackgroundPixmap( QPixmap(locate("appdata","pics/bk_frame2.png")) );
    pixmap_run->setPixmap( locate( "icon", "hicolor/48x48/apps/kconfigure.png" ) );
    Frame14Layout->addWidget( pixmap_run );

    QSpacerItem* spacer_10 = new QSpacerItem( 20, 20, QSizePolicy::Minimum, QSizePolicy::Expanding );
    Frame14Layout->addItem( spacer_10 );

    label_info = new QLabel( Frame14, "label_info" );
    label_info->setBackgroundPixmap( QPixmap(locate("appdata","pics/bk_frame.png")) );
    label_info->setText( "" );
    Frame14Layout->addWidget( label_info );

    QSpacerItem* spacer_11 = new QSpacerItem( 20, 20, QSizePolicy::Minimum, QSizePolicy::Expanding );
    Frame14Layout->addItem( spacer_11 );
    pageLayout_4->addWidget( Frame14 );

    QVBoxLayout *Layout14 = new QVBoxLayout;
    Layout14->setSpacing( 6 );
    Layout14->setMargin( 0 );

    QHBoxLayout *Layout13 = new QHBoxLayout;
    Layout13->setSpacing( 6 );
    Layout13->setMargin( 0 );

    QLabel *label_runstatus = new QLabel( this, "label_runstatus" );
    label_runstatus->setText( i18n( "Status :" ) );
    Layout13->addWidget( label_runstatus );

    label_runstatusinfo = new QLabel( this, "label_runstatusinfo" );
    label_runstatusinfo->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)7, (QSizePolicy::SizeType)5, label_runstatusinfo->sizePolicy().hasHeightForWidth() ) );
    label_runstatusinfo->setText( i18n( "<b>Stop</b>" ) );
    Layout13->addWidget( label_runstatusinfo );

    pixmap_runstatus = new KAnimWidget( QString("kde"), 22, this, "animWidget");
    Layout13->addWidget( pixmap_runstatus );
    Layout14->addLayout( Layout13 );

    view_status = new MakeWidget( this, "view_status" );
    Layout14->addWidget( view_status );

    QGroupBox *GroupBox21 = new QGroupBox( this, "GroupBox21" );
    GroupBox21->setTitle( i18n( "Actions" ) );
    GroupBox21->setColumnLayout(0, Qt::Vertical );
    GroupBox21->layout()->setSpacing( 0 );
    GroupBox21->layout()->setMargin( 0 );
    QHBoxLayout *GroupBox21Layout = new QHBoxLayout( GroupBox21->layout() );
    GroupBox21Layout->setAlignment( Qt::AlignTop );
    GroupBox21Layout->setSpacing( 6 );
    GroupBox21Layout->setMargin( 11 );

    button_runstart = new QPushButton( GroupBox21, "button_runstart" );
    button_runstart->setText( i18n( "&Start" ) );
		connect( button_runstart, SIGNAL( clicked() ), this, SLOT( slotStart() ) );
    GroupBox21Layout->addWidget( button_runstart );

    button_runstop = new QPushButton( GroupBox21, "button_runstop" );
    button_runstop->setText( i18n( "Stop" ) );
		connect( button_runstop, SIGNAL( clicked() ), this, SLOT( slotStop() ) );
    GroupBox21Layout->addWidget( button_runstop );

    combo_runresume = new QComboBox( FALSE, GroupBox21, "combo_runresume" );
    combo_runresume->insertItem( i18n( "Start all process" ) );
    combo_runresume->insertItem( i18n( "Start from compile" ) );
    combo_runresume->insertItem( i18n( "Clean and continue compile" ) );
    combo_runresume->insertItem( i18n( "Compile only" ) );
    combo_runresume->insertItem( i18n( "Install only" ) );
    combo_runresume->insertItem( i18n( "UnInstall" ) );
    combo_runresume->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)7, (QSizePolicy::SizeType)0, combo_runresume->sizePolicy().hasHeightForWidth() ) );
    GroupBox21Layout->addWidget( combo_runresume );
    Layout14->addWidget( GroupBox21 );
    pageLayout_4->addLayout( Layout14 );
}

/** Execute a command */
void PageRun::execute( const char *command)
{
	QString Comm_Args;
	QString SFile = command;
	int buflen = SFile.length();

  if( q.isRunning()==true ){
		KMessageBox::error(0, i18n("SORRY !\n\nWait until the process finish.\n"), i18n("I cannot do this !"), false);
		return;
		}

	// and identify after space like arguments
	for( int i = 0; i < buflen; i++ )
	{
	if( *command == ' ' )
		{
		q << Comm_Args;
		Comm_Args = "";
		} else {
		Comm_Args += *command;
		}
	++command;
	}
	q << Comm_Args;

	pixmap_runstatus->start();
  q.start( KProcess::NotifyOnExit, KProcess::AllOutput );
}

/** Set path */
void PageRun::setPath( const KURL &url)
{
	qDir.setCurrent( url.directory(false,true) );
}

/** Get configure arguments */
void PageRun::getConfigureArgs(const QString &args)
{
	ArgumentsConfigure = args;
}

/** Get Make arguments */
void PageRun::getMakeArgs(const QString &args)
{
	ArgumentsMake = args;
}

/** Get Make arguments */
void PageRun::getInstallUser(const QString &args)
{
	if( args == "root" )
		{
		ArgumentsInstall = "kdesu -t ";
		isRootInstall = true;
		}
		else
		{
		ArgumentsInstall = "";
		isRootInstall = false;
		}
}

/** Get Make arguments */
void PageRun::getInstallArgs(const QString &args)
{
	if( args == "install" )
		{
		ArgumentsInstall += "make install";
		ArgumentInstall = "make install";
		}
		else if ( args == "check" )
			{
			ArgumentsInstall += "checkinstall";
			ArgumentInstall = "CheckInstall";
			}
			else if ( args == "debian" )
				{
				ArgumentInstall = "Debian package";
				}
				else
					{
					ArgumentsInstall += "make " + args;
					ArgumentInstall = "make " + args;
					}
}

/** Start process */
void PageRun::slotStart()
{
// LEVELS
// 0 - Configure
// 1 - Compile
// 2 - Install
// 3 - UnInstall
// 4 - Clean

	switch( combo_runresume->currentItem() )
	{
	case 0:
		levelstatus = levelbegin;
		levelend = 2;
		startActions();
		break;
	case 1:
		levelstatus = 1;
		levelend = 2;
		startActions();
		break;
	case 2:
		levelstatus = 4;
		levelend = 2;
		startActions();
		break;
	case 3:
		levelstatus = 1;
		levelend = 1;
		startActions();
		break;
	case 4:
		levelstatus = 2;
		levelend = 2;
		startActions();
		break;
	case 5:
		levelstatus = 3;
		levelend = 3;
		startActions();
		break;
	}
}

/** Stop the process */
void PageRun::slotStop()
{
	q.kill();
}

/** Slot output message */
void PageRun::slotOutputMessages(KProcess*,char *buffer,int buflen)
{
//    QCString temp = QCString( buffer,buflen+1 );
//    temp = temp.left(temp.length()-1);
//    view_status->insertStdoutLine(temp /*QCString(buffer,buflen+1)*/);
    view_status->append( QCString( buffer,buflen+1 ) );
//	for( int i = 0; i < buflen; i++ )
//	{
//	if( *buffer == '\n' )
//		{
//		view_status->insertLine( streamLine );
//		view_status->setCursorPosition(view_status->numLines(),0);
//		streamLine = "";
//		} else {
//		streamLine += *buffer;
//		}
//	++buffer;
//	}
}

/** Start level */
void PageRun::startLevel(const int &level)
{
	QString info="";

	levelbegin = level;

	info += i18n("<p>Now you are ready to compile.</p><p/>");

	if( levelbegin == 0 ) // CONFIGURE SCRIPT EXISTS
	{
		info += i18n("<p><b>Configure</p><p>");
		if( ArgumentsConfigure.isEmpty() )
			info += i18n("Without arguments.");
			else
			info += "<FONT SIZE=-1>"+ArgumentsConfigure+"</FONT>";
		info += "</p>";
	}

	info += i18n("<p><b>Make</b></p><p>");
	if( ArgumentsMake.isEmpty() )
		info += i18n("Without arguments.");
		else
		info += "<FONT SIZE=-1>"+ArgumentsMake+"</FONT>";
	info += "</p>";

	info += i18n("<p><b>Install</b></p><p>");
	if( isRootInstall )
		{ info += "<FONT SIZE=-1>" + i18n("As root user.") + "</FONT>"; }
		else { info += "<FONT SIZE=-1>" + i18n("As current user.") + "</FONT>"; }
	info += "</p>";

	info += "<p><FONT SIZE=-1>" + ArgumentInstall + "</FONT></p>";

	label_info->setText(info);
}

/** Select what action I need to do */
void PageRun::startActions()
{
	q.clearArguments();

	switch( levelstatus )
	{
	case 0:
		label_runstatusinfo->setText( i18n("<b>Configuring dependencies...</b>") );
		execute(( "./configure "+ArgumentsConfigure ).latin1() );
		break;
	case 1:
		label_runstatusinfo->setText( i18n("<b>Compiling sources...</b>") );
		execute(( "make "+ArgumentsMake ).latin1() );
		break;
	case 2:
		label_runstatusinfo->setText( i18n("<b>Installing...</b>") );
		execute( ArgumentsInstall.latin1() );
		break;
	case 3:
		label_runstatusinfo->setText( i18n("<b>UnInstalling...</b>") );
		if( isRootInstall )
			execute("kdesu -t make uninstall");
			else
			execute("make uninstall");
		break;
	case 4:
		label_runstatusinfo->setText( i18n("<b>Cleaning sources...</b>") );
		execute("make clean");
		break;
	}
}

/** Finish */
void PageRun::slotFinishAction()
{
	pixmap_runstatus->stop();
	label_runstatusinfo->setText( i18n("<b>Stop</b>") );

	if( q.normalExit() && q.exitStatus()!=0 )
	{
	KMessageBox::error(0, i18n("ERROR !\n\nIt does not have a valid exit status."), i18n("Error"), false);
	return;
	}

	if( q.normalExit() && q.exitStatus()==0 )
		{
		if( levelstatus < levelend )
			{
			levelstatus++;
			startActions();
			} else if( levelstatus == 4 )
				{
				levelstatus = 1;
				startActions();
				} else if( levelstatus == levelend )
					{
					KNotifyClient::event("finish", i18n("The process has finished") );
					}
		}
}
