/***************************************************************************
                          pagerun.h  -  description
                             -------------------
    begin                : Sat Apr 28 2001
    copyright            : (C) 2001 by Javier Campos
    email                : javi_cms@terra.es
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PAGERUN_H
#define PAGERUN_H

//#include "coutputwidget.h"
#include "makewidget.h"

#include <kprocess.h>
#include <kurl.h>
#include <kanimwidget.h>

#include <qwidget.h>
#include <qlabel.h>
#include <qmultilineedit.h>
#include <qcombobox.h>
#include <qpushbutton.h>
#include <qdir.h>

/**Make all the process
  *@author Javier Campos
  */

class PageRun : public QWidget  {
   Q_OBJECT
public: 
	PageRun(QWidget *parent=0, const char *name=0);
	~PageRun();
  /** Set path */
  void setPath( const KURL &);
  /** Get configure arguments */
  void getConfigureArgs(const QString &);
  /** Get Make arguments */
  void getMakeArgs(const QString &);
  /** Get Install user */
  void getInstallUser(const QString &);
  /** Get Install arguments */
  void getInstallArgs(const QString &);
  /** Start level */
  void startLevel(const int &level);
private: // Private methods
  /** Init Graphical Interface */
  void initGUI();
  /** Execute a command */
  void execute( const char *command);
  /** Select what action I need to do */
  void startActions();
private: // Private attributes
  QLabel *label_info;
	KAnimWidget *pixmap_runstatus;
  /** Status */
  QLabel *label_runstatusinfo;
  /** Output messages */
  MakeWidget *view_status;
  /** Start */
  QPushButton *button_runstart;
  /** Stop */
  QPushButton *button_runstop;
  /** Resume actions */
  QComboBox *combo_runresume;
  /** Processes */
  KShellProcess q;
  /** File path */
  QDir qDir;
  /** Configure arguments */
  QString ArgumentsConfigure;
  /** Make arguments */
  QString ArgumentsMake;
  /** Install arguments */
  QString ArgumentsInstall;
  /** Select level */
  int levelstatus;
  /** Level end */
  int levelend;
  /** Begin mode */
  int levelbegin;
  /** Is root install? */
  bool isRootInstall;
  /** Install Argument */
  QString ArgumentInstall;
private slots: // Private slots
  /** Stop the process */
  void slotStop();
  /** Start process */
  void slotStart();
  /** Slot output message */
  void slotOutputMessages(KProcess*,char *buffer,int buflen);
  /** Finish */
  void slotFinishAction();
};

#endif
