/***************************************************************************
                          pageview.h  -  description
                             -------------------
    begin                : Thu May 3 2001
    copyright            : (C) 2001 by Javier Campos
    email                : javi_cms@terra.es
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PAGEVIEW_H
#define PAGEVIEW_H

#include <kurl.h>

#include <qwidget.h>
#include <qdir.h>
#include <qcombobox.h>
#include <qtextview.h>

/**Page view files
  *@author Javier Campos
  */

class PageView : public QWidget  {
   Q_OBJECT
public: 
	PageView(QWidget *parent=0, const char *name=0);
	~PageView();
  /** Set initial Path */
  void init( const KURL &url );
  /** Do I find files to read? */
  bool foundFiles();
private: // Private methods
  /** Init Graphical Interface */
  void initGUI();
  /** Find files to view */
  void findFiles();
private: // Private attributes
  /** Combo files */
  QComboBox *combo_files;
  /** Qdir current */
  QDir qDir;
  /** View files */
  QTextView *view_files;
private slots: // Private slots
  /** Combo box */
  void slotView( int index );
};

#endif
