/***************************************************************************
                          predefined.cpp  -  description
                             -------------------
    begin                : Sun Apr 29 2001
    copyright            : (C) 2001 by Javier Campos
    email                : javi_cms@terra.es
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "predefined.h"
#include "predefined.moc"

#include <kstddirs.h>
#include <ksimpleconfig.h>

#include <qfile.h>

predefined::predefined(const QString &pFileName, bool bReadOnly) : KSimpleConfig( pFileName, bReadOnly)
{
}

predefined::~predefined()
{
}

/** Get groups */
QStringList predefined::getGroups()
{
	return	this->groupList();
}

/** Select a group */
void predefined::selectGroup( const QString &group )
{
	this->setGroup( group );
	Entries = this->entryMap( group);
	EntriesIT = Entries.begin();
}

/** Next entry */
void predefined::nextEntry()
{
	EntriesIT++;
}

/** Return eof when entry is finish */
bool predefined::EntryEOF()
{
	if( EntriesIT.key() == QString::null )
		return true;
		else
		return false;
}
/** Return key */
QString predefined::key()
{
	return EntriesIT.key();
}

/** Read data */
QString predefined::data()
{
	return EntriesIT.data();
}

/** Add group */
void predefined::addGroup( const QString &group)
{
	this->setGroup( group );
	currentGroup = group;
}

/** Add entries */
void predefined::addItem( const QString &key, const QString &data)
{
	this->writeEntry( key, data);
}
