/***************************************************************************
                          predefined.h  -  description
                             -------------------
    begin                : Sun Apr 29 2001
    copyright            : (C) 2001 by Javier Campos
    email                : javi_cms@terra.es
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PREDEFINED_H
#define PREDEFINED_H

#include <ksimpleconfig.h>

#include <qstring.h>
#include <qstringlist.h>
#include <qmap.h>

/**Predefined save/read options
  *@author Javier Campos
  */

class predefined : public KSimpleConfig  {
   Q_OBJECT
public:
	predefined(const QString &pFileName, bool bReadOnly = false);
	~predefined();
  /** Get groups */
  QStringList getGroups();
  /** Select a group */
  void selectGroup( const QString &group );
  /** Return eof when entry is finish */
  bool EntryEOF();
  /** Next entry */
  void nextEntry();
  /** Read data */
  QString data();
  /** Return key */
  QString key();
  /** Add group */
  void addGroup( const QString &group);
  /** Add entries */
  void addItem( const QString &key, const QString &data);
private: // Private attributes
  /** Groups of Data */
  QStringList Groups;
  QStringList::Iterator ValuesIT;
	/** Entries */
	QMap<QString,QString> Entries;
  /** Current group */
  QString currentGroup;
	QMap<QString,QString>::Iterator EntriesIT;

};

#endif
